"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const generate_unique_id_1 = __importDefault(require("../../utils/generate-unique-id"));
class RequestEvent {
    constructor(requestFilterRule, requestContext, requestInfo) {
        this.requestFilterRule = requestFilterRule;
        this._requestContext = requestContext;
        this._requestInfo = requestInfo;
        this.id = generate_unique_id_1.default();
    }
    async setMock(mock) {
        await this._requestContext.session.setMock(this.id, mock);
    }
    get requestOptions() {
        return this._requestContext.reqOpts;
    }
    get isAjax() {
        return this._requestInfo.isAjax;
    }
}
exports.default = RequestEvent;module.exports = exports.default;

